--[[
    Broker_GarbageFu by LordFarlander
    Version 3.0.11
    $Revision: 11 $

    A conversion of Fubar_GarbageFu by wmrojer
]]--

--[[
Copyright (c) 2008, LordFarlander
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
]]--

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Broker_GarbageFu" );
local qtip = LibStub( "LibQTip-1.0" );
local dewdrop = LibStub( "Dewdrop-2.0" );
local abacus = LibStub( "LibAbacus-3.0" );
local crayon = LibStub( "LibCrayon-3.0" );
local PT3 = LibStub( "LibPeriodicTable-3.1" );

Broker_GarbageFu = LibStub( "AceAddon-3.0" ):NewAddon( "Broker_GarbageFu", "AceEvent-3.0", "AceHook-3.0", "AceConsole-3.0", "AceTimer-3.0" );
Broker_GarbageFu.version = "3.0.11";
Broker_GarbageFu.date = ("$Date: 2008-12-11 20:50:55 +0000 (Thu, 11 Dec 2008) $"):sub( 8, 17 );
Broker_GarbageFu.printFrame = DEFAULT_CHAT_FRAME;
Broker_GarbageFu.debugFrame = DEFAULT_CHAT_FRAME;

local clickProvider, clickPrototype, baseclickCellPrototype = qtip:CreateCellProvider( qtip.LabelProvider );

function clickPrototype:InitializeCell()
    baseclickCellPrototype.InitializeCell( self );
end--clickPrototype:InitializeCell()

function clickPrototype:SetupCell( tooltip, value, justification, font, class, item )
  self:EnableMouse( true );
  self:SetScript( "OnMouseDown", function() class:OnClickItem( item ) end );
  return baseclickCellPrototype.SetupCell( self, tooltip, value, justification, font );
end--clickPrototype:SetupCell( tooltip, value, justification, font, class, item )

------------------------------------------------------------------------------------------------------
-- Simple Property functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:UpdateDisplay()
    self:OnTextUpdate();
    self:UpdateTooltip();
end--Broker_GarbageFu:UpdateDisplay()

function Broker_GarbageFu:GetDropThreshold()
    return self.db.profile.threshold;
end--Broker_GarbageFu:GetDropThreshold()

function Broker_GarbageFu:IsDropThreshold( value )
    return self.db.profile.threshold == tonumber( value );
end--Broker_GarbageFu:IsDropThreshold( value )

function Broker_GarbageFu:GetMoneyFormat()
    return self.db.profile.moneyformat;
end--Broker_GarbageFu:GetMoneyFormat()

function Broker_GarbageFu:GetNameLength( value )
    return self.db.profile.namelength;
end--Broker_GarbageFu:GetNameLength( value )

function Broker_GarbageFu:IsIgnoringAmmoBag()
    return self.db.profile.ignoreammobag;
end--Broker_GarbageFu:IsIgnoringAmmoBag()

function Broker_GarbageFu:IsIgnoringSoulBag()
    return self.db.profile.ignoresoulbag;
end--Broker_GarbageFu:IsIgnoringSoulBag()

function Broker_GarbageFu:IsIgnoringHerbBag()
    return self.db.profile.ignoreherbbag;
end--Broker_GarbageFu:IsIgnoringHerbBag()

function Broker_GarbageFu:IsIgnoringEnchBag()
    return self.db.profile.ignoreenchbag;
end--Broker_GarbageFu:IsIgnoringEnchBag()

function Broker_GarbageFu:IsIgnoringEngBag()
    return self.db.profile.ignoreengbag;
end--Broker_GarbageFu:IsIgnoringEngBag()

function Broker_GarbageFu:IsIgnoringGemBag()
    return self.db.profile.ignoregembag;
end--Broker_GarbageFu:IsIgnoringGemBag()

function Broker_GarbageFu:IsIgnoringLeatherBag()
    return self.db.profile.ignoreleatherbag;
end--Broker_GarbageFu:IsIgnoringLeatherBag()

function Broker_GarbageFu:IsIgnoringMinBag()
    return self.db.profile.ignoreminbag;
end--Broker_GarbageFu:IsIgnoringMinBag()

function Broker_GarbageFu:IsSafeToDelete()
    return self.vars.safedelete;
end

function Broker_GarbageFu:SetSafeToDelete(value)
    self.vars.safedelete = value;
end

function Broker_GarbageFu:IsItemIcon()
    return self.db.profile.itemicon;
end

function Broker_GarbageFu:IsPriceType()
    return self.db.profile.pricetype;
end

function Broker_GarbageFu:IsShowingBagSlots()
    return self.db.profile.showbagslots;
end

function Broker_GarbageFu:IsShowingTotalValue()
    return self.db.profile.showtotalvalue;
end

function Broker_GarbageFu:IsShowingFirstDrop()
    return self.db.profile.showfirstdrop;
end

function Broker_GarbageFu:IsShowingFreeSlots()
    return self.db.profile.showfreeslots;
end

function Broker_GarbageFu:ToggleShowFreeSlots()
    self.db.profile.showfreeslots = not self.db.profile.showfreeslots;
    self:OnTextUpdate();
end

function Broker_GarbageFu:IsShowingTotalSlots()
    return self.db.profile.showtotalslots;
end

function Broker_GarbageFu:IsShowingStatistics()
    return self.db.profile.showstatistics;
end

------------------------------------------------------------------------------------------------------
-- A little more complicate property functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:IsDropItem( itemid )
    return type( self.db.profile.dropitem[itemid] ) ~= "nil";
end--Broker_GarbageFu:IsDropItem( itemid )

function Broker_GarbageFu:ToggleDropItem( itemid )
    if( self.db.profile.dropitem[itemid] ) then
        self.db.profile.dropitem[itemid] = nil;
    else
        self.db.profile.dropitem[itemid] = true;
        self.db.profile.keepitem[itemid] = nil;
    end--if
    self:UpdateDisplay();
end--Broker_GarbageFu:ToggleDropItem( itemid )

function Broker_GarbageFu:IsKeepItem( itemid )
    return type( self.db.profile.keepitem[itemid] ) ~= "nil";
end--Broker_GarbageFu:IsKeepItem( itemid )

function Broker_GarbageFu:ToggleKeepItem( itemid )
    if( self.db.profile.keepitem[itemid] ) then
        self.db.profile.keepitem[itemid] = nil;
    else
        self.db.profile.keepitem[itemid] = true;
        self.db.profile.dropitem[itemid] = nil;
    end--if
    self:UpdateDisplay();
end--Broker_GarbageFu:ToggleKeepItem( itemid )

------------------------------------------------------------------------------------------------------
-- Constant data
------------------------------------------------------------------------------------------------------

Broker_GarbageFu.vars = {
    moneyformats = {
        { name = L["Condensed"], ex = abacus:FormatMoneyCondensed( 123456, true, true ) },
        { name = L["Short"], ex = abacus:FormatMoneyShort( 123456, true, true ) },
        { name = L["Full"], ex = abacus:FormatMoneyFull( 123456, true, true ) },
        { name = L["Extended"], ex = abacus:FormatMoneyExtended( 123456, true, true) },
    },
    sets = {
        { id = "Consumable.Food", name = L["Food"], sub = { -- foodall
            { id = "Consumable.Food.Edible.Basic.Non-Conjured", name = L["Normal Food"], }, -- food
            { id = "Consumable.Food.Edible.Bonus", name = L["Bonus Food"], }, --foodbonus
            { id = "Consumable.Food.Buff", name = L["Stat Food"], }, -- foodstat
            { id = "Consumable.Food.Edible.Combo", name = L["Combo Food"], },
            { id = "Consumable.Food.Edible.Basic.Conjured", name = L["Conjured Bread"], }, -- foodbreadconjured
            { id = "Consumable.Food.Edible.Battleground", name = L["Battleground Bread"], },
            { id = "Consumable.Food.Inedible", name = L["Raw Food"], }, -- foodraw
            { id = "Consumable.Food.Bread", name = L["Bread"], }, -- foodclassbread
            { id = "Consumable.Food.Fish", name = L["Fish"], }, -- foodclassfish
            { id = "Consumable.Food.Meat", name = L["Meat"], }, -- foodclassmeat
            { id = "Consumable.Food.Cheese", name = L["Cheese"], }, -- foodclasscheese
            { id = "Consumable.Food.Fruit", name = L["Fruit"], }, -- foodclassfruit
            { id = "Consumable.Food.Fungus", name = L["Fungus"], }, -- foodclassfungus
            { id = "Consumable.Food.Misc", name = L["Misc"], },
        }, },
        { id = "Consumable.Water", name = L["Water"], sub = { -- waterall
            { id = "Consumable.Water.Basic", name = L["Normal Water"], }, -- water
            { id = "Consumable.Water.Percentage", name = L["Percent Water"], }, -- waterperc
            { id = "Consumable.Water.Conjured", name = L["Conjured Water"], }, -- waterconjured
            { id = "Consumable.Water.Battleground", name = L["Battleground Water"], },
        }, },
        { id = "Misc.Booze", name = L["Booze"], }, -- booze
        { id = "Tradeskill.Mat.ByProfession", name = L["Tradeskill"], sub = { -- tradeskill
            { id = "Tradeskill.Mat.ByProfession.Alchemy", name = L["Alchemy"], }, -- tradeskillalchemy
            { id = "Tradeskill.Mat.ByProfession.Blacksmithing", name = L["Blacksmithing"], }, -- tradeskillblacksmithing
            { id = "Tradeskill.Mat.ByProfession.Cooking", name = L["Cooking"], }, -- tradeskillcooking
            { id = "Tradeskill.Mat.ByProfession.Enchanting", name = L["Enchanting"], }, -- tradeskillenchanting
            { id = "Tradeskill.Mat.ByProfession.Engineering", name = L["Engineering"], }, -- tradeskillengineering
            { id = "Tradeskill.Mat.ByProfession.First Aid", name = L["First Aid"], }, -- tradeskillfirstaid
            { id = "Tradeskill.Mat.ByProfession.Jewelcrafting", name = L["Jewelcrafting"], },
            { id = "Tradeskill.Mat.ByProfession.Leatherworking", name = L["Leatherworking"], }, -- tradeskillleatherworking
            { id = "Tradeskill.Mat.ByProfession.Tailoring", name = L["Tailoring"], }, -- tradeskilltailoring
            { id = "Tradeskill.Mat.ByProfession.Poisons", name = L["Poison"], }, -- tradeskillpoison
            { id = "Tradeskill.Mat.ByProfession.Smelting", name = L["Smelting"], }, -- tradeskillsmelting
        }, },
        { id = "Tradeskill.Tool", name = L["Tradeskill Tools"], sub = { -- tradeskilltools
            { id = "Tradeskill.Tool.Alchemy", name = L["Alchemy"], },
            { id = "Tradeskill.Tool.Blacksmithing", name = L["Blacksmithing"], },
            { id = "Tradeskill.Tool.Enchanting", name = L["Enchanting"], },
            { id = "Tradeskill.Tool.Engineering", name = L["Engineering"], },
            { id = "Tradeskill.Tool.Fishing", name = L["Fishing"], },
            { id = "Tradeskill.Tool.Jewelcrafting", name = L["Jewelcrafting"], },
            { id = "Tradeskill.Tool.Mining", name = L["Mining"], },
            { id = "Tradeskill.Tool.Skinning", name = L["Skinning"], },
        }, },
        { id = "Tradeskill.Gather", name = L["Gathered"], sub = { -- gatherskill
            { id = "Tradeskill.Gather.Fishing", name = L["Fishing"], }, -- gatherskillfishing
            { id = "Tradeskill.Gather.Disenchant", name = L["Disenchant"], }, -- gatherskilldisenchant
            { id = "Tradeskill.Gather.Herbalism", name = L["Herbalism"], }, -- gatherskillherbalism
            { id = "Tradeskill.Gather.Mining", name = L["Mining"], }, -- gatherskillmining
            { id = "Tradeskill.Gather.Pickpocketing", name = L["Pickpocketing"], },
            { id = "Tradeskill.Gather.Prospecting", name = L["Prospecting"], },
            { id = "Tradeskill.Gather.Skinning", name = L["Skinning"], }, -- gatherskillskinning
        }, },
        { id = "Tradeskill.Recipe", name = L["Recipe"], auctionOnly=true, sub = { -- recipe
            { id = "Tradeskill.Recipe.Alchemy", name = L["Alchemy"], auctionOnly=true}, -- recipealchemy
            { id = "Tradeskill.Recipe.Blacksmithing", name = L["Blacksmithing"], auctionOnly=true}, -- recipeblacksmith
            { id = "Tradeskill.Recipe.Cooking", name = L["Cooking"], auctionOnly=true}, -- recipecooking
            { id = "Tradeskill.Recipe.Enchanting", name = L["Enchanting"], auctionOnly=true}, -- recipeenchanting
            { id = "Tradeskill.Recipe.Engineering", name = L["Engineering"], auctionOnly=true}, -- recipeengineering
            { id = "Tradeskill.Recipe.Fishing", name = L["Fishing"], auctionOnly=true}, -- recipefishing
            { id = "Tradeskill.Recipe.First Aid", name = L["First Aid"], auctionOnly=true}, -- recipefirstaid
            { id = "Tradeskill.Recipe.Jewelcrafting", name = L["Jewelcrafting"], auctionOnly=true},
            { id = "Tradeskill.Recipe.Leatherworking", name = L["Leatherworking"], auctionOnly=true}, -- recipeleatherworking
            { id = "Tradeskill.Recipe.Tailoring", name = L["Tailoring"], auctionOnly=true}, -- recipetailoring
        }, },
        { id = "Reagent.Ammo", name = L["Ammunition"], auctionOnly=true }, -- ammo
        { id = "Consumable.Bandage", name = L["Bandages"], }, -- bandages
        { id = "Misc.Engineering.Explosives", name = L["Explosives"], }, -- explosives
        { id = "QuestMats.Darkmoon Faire", name = L["Darkmoon Fair"], }, -- faire
        { id = "Misc.Engineering.Fireworks", name = L["Fireworks"], }, -- fireworks
        { id = "Consumable.Potion", name = L["Potions"], sub = { -- potionall
            { id = "Consumable.Potion.Recovery.Healing", name = L["Heal Potions"], }, -- potionhealall
            { id = "Consumable.Potion.Recovery.Mana", name = L["Mana Potions"], }, -- potionmanaall
            { id = "Consumable.Buff.Rage.Self", name = L["Rage Potions"], }, -- potionrage
            { id = "Consumable.Potion.Other.Cure", name = L["Cure Potions"], }, -- potioncure
            { id = "Consumable.Potion.Buff", name = L["Buff Potions"], }, -- potionbuff
        }, },
        { id = "Consumable.Scroll", name = L["Scrolls"], }, -- scrolls
        { id = "Reagent.Class", name = L["Reagents"], sub = { -- reagent
            { id = "Reagent.Class.Paladin", name = L["Paladin"], }, -- reagentpaladin
            { id = "Reagent.Class.Druid", name = L["Druid"], }, -- reagentdruid
            { id = "Reagent.Class.Mage", name = L["Mage"], }, -- reagentmage
            { id = "Reagent.Class.Priest", name = L["Priest"], }, -- reagentpriest
            { id = "Reagent.Class.Rogue", name = L["Rogue"], }, -- reagentrogue
            { id = "Reagent.Class.Shaman", name = L["Shaman"], }, -- reagentshaman
            { id = "Reagent.Class.Warlock", name = L["Warlock"], }, -- reagentwarlock
        }, },
        { id = "Consumable.Weapon Buff", name = L["Weapon Enchants"], sub = { -- weapontempenchants
            { id = "Consumable.Weapon Buff.Poison", name = L["Poisons"], }, -- poisons
            { id = "Consumable.Weapon Buff.Oil", name = L["Oil"], },
            { id = "Consumable.Weapon Buff.Stone", name = L["Stones"], },
        }, },
        { id = "Misc.Mount", name = L["Mounts"], }, -- mounts
        { id = "Misc.Minipet", name = L["Mini Pets"], }, -- minipetall
    },
    bags = {},
    items = {},
    pricecache = {},
    auctioncache = {},
    colors = {},
};

------------------------------------------------------------------------------------------------------
-- FuBar required functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:OnInitialize()
    local AceConfigReg = LibStub( "AceConfigRegistry-3.0" );
    local AceConfigDialog = LibStub( "AceConfigDialog-3.0" );
    local defaults = {
        profile = {
            moneyformat = 1,
            namelength = 32,
            ignoreammobag = true,
            ignoresoulbag = false,
            ignoreherbbag = false,
            ignoreenchbag = false,
            ignoreengbag = false,
            ignoregembag = false,
            ignoreminbag = false,
            ignoreleatherbag = false;
            sellallbutton = true,
            sellonlygrey = true,
            sellonopen = false,
            pricetype = false,
            garbageprices = false,
            itemicon = false,
            showtotalvalue = false,
            showfirstdrop = true,
            showbagslots = true,
            showtotalslots = true,
            showfreeslots = true,
            showstatistics = true,
            version = "",
            textcolor = { r = 0.2, g = 0.8, b = 1.0 };
            threshold = 0,
            dropsets = {},
            dropitem = {},
            keepsets = {},
            keepitem = {},
            droptypes = {},
            keeptypes = {},
            auctionsets = {},
            auctionitem = {},
            auctioncache = {},
            auctionThreshold = 3;
            auctionaddonsorder = {},
            vendoraddonsorder = {},
        },
        global = {
            overrideprices = {},
        },
        realm = {
            auctioncache = {},
            --    Added by Scott set default for Total value of garbage items dropped
            garbagedropped = { ['*'] = 0 },
            --    Added by Scott set default for Total value of garbage items sold
            garbageprofit = { ['*'] = 0 },
        },
    };
    local options = {
        type = "group",
        handler = self,
        args = {
            dropthreshold = {
                type = "select",
                order = 1,
                name = L["Drop Threshold"],
                desc = L["Drop Threshold"],
                values = function( info )
                             local values = {};

                             for a = 0, 6 do
                                 values[a] = info.handler.vars.colors[a].hex .. info.handler.vars.colors[a].desc .. "|r";
                             end--for
                             return values;
                         end;
                get  = "GetDropThreshold",
                set  = function( info, value )
                           info.handler.db.profile.threshold = value;
                           info.handler:UpdateDisplay();
                       end,
            },
            moneyformat = {
                type = "select",
                order = 2,
                name = L["Money Format"],
                desc = L["Money Format"],
                values = function( info )
                             local values = {};

                             for a, f in ipairs( info.handler.vars.moneyformats ) do
                                 values[a] = f.name .. "\t" .. f.ex;
                             end--for
                             return values;
                         end;
                get = "GetMoneyFormat",
                set = function( info, value )
                          info.handler.db.profile.moneyformat = value;
                          info.handler:UpdateDisplay();
                      end,
            },
            namelength = {
                type = "range",
                order = 3,
                name = L["Max Item Name Length"],
                desc = L["Max Item Name Length"],
                min = 5,
                max = 32,
                bigStep = 1,
                get  = "GetNameLength",
                set  = function( info, value )
                           info.handler.db.profile.namelength = value;
                           info.handler:OnTextUpdate();
                       end,
            },
            itemicon = {
                type = "toggle",
                order = 4,
                name = L["Use Items Icon on Toolbar"],
                desc = L["Use Items Icon on Toolbar"],
                get  = "IsItemIcon",
                set  = function( info, value )
                           info.handler.db.profile.itemicon = value;
                           if( not value ) then
                               info.handler.ldbobj.icon = "Interface\\AddOns\\Broker_GarbageFu\\Icon";
                           else
                               info.handler:OnTextUpdate();
                           end--if
                       end,
            },
            showbagslots = {
                type = "toggle",
                order = 5,
                name = L["Show Bag slots on Toolbar"],
                desc = L["Show Bag slots on Toolbar"],
                get  = "IsShowingBagSlots",
                set  = function( info, value )
                           info.handler.db.profile.showbagslots = value;
                           info.handler:OnTextUpdate();
                       end,                        
            },
            showtotalslots = {
                type = "toggle",
                order = 6,
                name = L["Show Total slots"],
                desc = L["Show Total slots"],
                get  = "IsShowingTotalSlots",
                set  = function( info, value )
                           info.handler.db.profile.showtotalslots = value;
                           info.handler:OnTextUpdate();
                       end,                        
            },
            totalvalue = {
                type = "toggle",
                order = 7,
                name = L["Show Total Garbage Value on Toolbar"],
                desc = L["Show Total Garbage Value on Toolbar"],
                get  = "IsShowingTotalValue",
                set  = function( info, value )
                           info.handler.db.profile.showtotalvalue = value;
                           info.handler:OnTextUpdate();
                       end,
            },
            firstdrop = {
                type = "toggle",
                order = 8,
                name = L["Show First Drop Item on Toolbar"],
                desc = L["Show First Drop Item on Toolbar"],
                get  = "IsShowingFirstDrop",
                set  = function( info, value )
                           info.handler.db.profile.showfirstdrop = value;
                           info.handler:OnTextUpdate();
                       end,
            },
            pricetype = {
                type = "toggle",
                order = 9,
                name = L["Show Price Type in Tooltip"],
                desc = L["Show Price Type in Tooltip"],
                get  = "IsPriceType",
                set  = function( info, value )
                           info.handler.db.profile.pricetype = value;
                           info.handler:UpdateTooltip();
                       end,
            },
            statistics = {
                type = "toggle",
                order = 10,
                name = L["Show Statistics"],
                desc = L["Show Statistics"],
                get  = "IsShowingStatistics",
                set  = function( info, value )
                           info.handler.db.profile.showstatistics = value;
                       end,
            },
            rescan = {
                type = "execute",
                order = 11,
                name = L["Rescan Prices"],
                desc = L["RescanPricesDesc"],
                func = "UpdateAllItemValues",
            },
            reset = {
                type = "execute",
                order = 12,
                name = L["Reset"],
                desc = L["ResetDesc"],
                func = function()
                           StaticPopup_Show( "BROKER_GARBAGEFU_RESET" );
                       end,
            },
        },
    };
    local bagoptions = {
        type = "group",
        handler = self,
        name = L["Special Bags"],
        args = {
            ignoreammobag = {
                type = "toggle",
                order = 1,
                name = L["Ignore Ammo Bags"],
                desc = L["Ignore Ammo Bags"],
                get  = "IsIgnoringAmmoBag",
                set  = function( info, value )
                           self.db.profile.ignoreammobag = value;
                           self:InitBagScan();
                       end,
            },
            ignoresoulbag = {
                type = "toggle",
                order = 2,
                name = L["Ignore Soulshard Bags"],
                desc = L["Ignore Soulshard Bags"],
                get  = "IsIgnoringSoulBag",
                set  = function( info, value )
                           self.db.profile.ignoresoulbag = value;
                           self:InitBagScan();
                       end,
            },
            ignoreherbbag = {
                type = "toggle",
                order = 3,
                name = L["Ignore Herb Bags"],
                desc = L["Ignore Herb Bags"],
                get  = "IsIgnoringHerbBag",
                set  = function( info, value )
                           self.db.profile.ignoreherbbag = value;
                           self:InitBagScan();
                       end,
            },
            ignoreengbag = {
                type = "toggle",
                order = 4,
                name = L["Ignore Engineering Bags"],
                desc = L["Ignore Engineering Bags"],
                get  = "IsIgnoringEngBag",
                set  = function( info, value )
                           self.db.profile.ignoreengbag = value;
                           self:InitBagScan();
                       end,
            },
            ignoregembag = {
                type = "toggle",
                order = 5,
                name = L["Ignore Gem Bags"],
                desc = L["Ignore Ammo Bags"],
                get  = "IsIgnoringGemBag",
                set  = function( info, value )
                           self.db.profile.ignoregembag = value;
                           self:InitBagScan();
                       end,
            },
            ignoreminbag = {
                type = "toggle",
                order = 6,
                name = L["Ignore Mining Bags"],
                desc = L["Ignore Mining Bags"],
                get  = "IsIgnoringMinBag",
                set  = function( info, value )
                           self.db.profile.ignoreminbag = value;
                           self:InitBagScan();
                       end,
            },
            ignoreleatherbag = {
                type = "toggle",
                order = 7,
                name = L["Ignore Leatherworking Bags"],
                desc = L["Ignore Leatherworking Bags"],
                get  = "IsIgnoringLeatherBag",
                set  = function( info, value )
                           self.db.profile.ignoreleatherbag = value;
                           self:InitBagScan();
                       end,
            },
        },
    };

    if( GarbageFu ) then
        options.args.copysettings = {
            type = "execute",
            order = -1,
            name = L["Copy setting from FuBar_GarbageFu"],
            desc = L["Copy setting from FuBar_GarbageFu"],
            func = "CopySettingsFromFuBar_GarbageFu",
        };
    end--if

--             self:BuildSellOptionsMenu( level - 1, value, inTooltip, value2 );
--             self:BuildVendorOptionMenu( level - 1, value, inTooltip, value2 );
--             self:BuildAuctionOptionMenu( level - 1, value, inTooltip, value2 );

    self.db = LibStub( "AceDB-3.0" ):New( "Broker_GarbageFuDB", defaults );
    
    local profileOptions = LibStub( "AceDBOptions-3.0" ):GetOptionsTable( self.db );

    self.db.RegisterCallback( self, "OnProfileChanged" );
    self.db.RegisterCallback( self, "OnProfileReset" );
    
    AceConfigReg:RegisterOptionsTable( "Broker_GarbageFu Main Options", options );
    AceConfigReg:RegisterOptionsTable( "Broker_GarbageFu Bag Options", bagoptions );
    AceConfigReg:RegisterOptionsTable( "Broker_GarbageFu Sell Options", self:BuildSellOptionsGroup() );
    AceConfigReg:RegisterOptionsTable( "Broker_GarbageFu Profile", profileOptions );
    AceConfigDialog:AddToBlizOptions( "Broker_GarbageFu Main Options", L["GarbageFu"] );
    AceConfigDialog:AddToBlizOptions( "Broker_GarbageFu Bag Options", L["Special Bags"], L["GarbageFu"] );
    AceConfigDialog:AddToBlizOptions( "Broker_GarbageFu Sell Options", L["Sell"], L["GarbageFu"] );
    AceConfigDialog:AddToBlizOptions( "Broker_GarbageFu Profile", L["Profile"], L["GarbageFu"] );

    -- Put stuff that only neeeds to be done once here
    -- Get Item quality colors
    for i = 0, 6 do
        self.vars.colors[i] = {
            desc = _G["ITEM_QUALITY" .. i .. "_DESC"],
        };
        self.vars.colors[i].r, self.vars.colors[i].g, self.vars.colors[i].b, self.vars.colors[i].hex = GetItemQualityColor( i );
    end
    -- Create Static dialog for Reset Settings
    StaticPopupDialogs["BROKER_GARBAGEFU_RESET"] = {
          text = L["Are you sure you want to reset all your settings for GarbageFU?"],
          button1 = TEXT( ACCEPT ),
          button2 = TEXT( CANCEL ),
          OnAccept = function()
                         Broker_GarbageFu.SettingsReset( self );
                     end,
          timeout = 0,
          whileDead = 1,
          hideOnEscape = 1,
    };
    if( not GarbageFu ) then
        GarbageFu = self;
    end--if
    -- Check for any needed upgrades of settings
    self:CheckSettings();
    -- Store AddOn version. In case we need to check it in the future for upgrades.
    self.db.profile.version = self.version;

    self.ldbobj = LibStub( "LibDataBroker-1.1" ):NewDataObject( L["GarbageFu"], {
            type = "data source",
            icon = "Interface\\AddOns\\Broker_GarbageFu\\Icon",
            label = L["GarbageFu"],
            text = L["GarbageFu"], -- To get Button Bin to work correctly when autohiding text
            OnClick = function( _, button )
                          self:OnClick( button );
                      end,
            OnEnter = function( frame )
                          local tooltip = qtip:Acquire( "Broker_GarbageFu_Tooltip", 3, "LEFT", "CENTER", "RIGHT" );

                          self.vars.frame = frame;
                          self.vars.tooltip = tooltip;
                          tooltip:EnableMouse( true );
                          self:UpdateTooltip();
                          tooltip:SmartAnchorTo( frame );
                          tooltip:Show();
                      end,
            OnLeave = function( frame )
                          local function HideTooltip( test )
                              if( MouseIsOver( self.vars.tooltip ) ) then
                                  return;
                              end;
                              self.vars.tooltip:SetScript( "OnLeave", nil );
                              qtip:Release( self.vars.tooltip );
                              self.vars.tooltip = nil;
                          end--HideTooltip()

                          if( MouseIsOver( self.vars.tooltip ) ) then
                              self.vars.tooltip:SetScript( "OnLeave", HideTooltip );
                          else
                              HideTooltip();
                          end--if
                      end,
        } );
        
    self.vars.initialized = true;
    self:InitVendor();
    self:InitAuction();
    self:UpdateAllItemValues()
    self:Update();
end--Broker_GarbageFu:OnInitialize()

function Broker_GarbageFu:CopySettingsFromFuBar_GarbageFu()
    local function DeleteAll( table )
        for i, _ in pairs( table ) do
            table[i] = nil;
        end--if
    end--function DeleteAll( table )
    local function CopyTable( to, from )
        for i, v in pairs( from ) do
            if( type( v ) == "table" ) then
                to[i] = {};
                CopyTable( to[i], v );
            else
                to[i] = v;
            end--if
        end--for
    end--CopyTable( to, from )

    DeleteAll( self.db.profile );
    DeleteAll( self.db.realm );
    DeleteAll( self.db.global );
    CopyTable( self.db.profile, GarbageFu.db.profile );
    CopyTable( self.db.realm, GarbageFu.db.realm );
    CopyTable( self.db.global, GarbageFu.db.account );
end--Broker_GarbageFu:CopySettingsFromFuBar_GarbageFu()

function Broker_GarbageFu:OnEnable()
    -- Stuff that needs to be done every time the mod is enabled
    self:SetSafeToDelete( false );
    if( self.vars.initialized  )then
        self:InitVendor();
        self:InitAuction();
    end--if
    self:MainInit();
    self:OnEnteringWorld();
    self:SetSafeToDelete( true );
end--Broker_GarbageFu:OnEnable()

function Broker_GarbageFu:OnDisable()
    self:SetSafeToDelete( false );
    self:HideSellAllButton();
end--Broker_GarbageFu:OnDisable()

function Broker_GarbageFu:OnProfileReset()
    self:OnProfileChanged();
end--Broker_GarbageFu:OnProfileReset()

function Broker_GarbageFu:OnProfileChanged()
    self:CheckSettings();
    if( self.vars.initialized ) then
        self:MainInit()
    end -- Reload all the settings if the profile was changed after we entered the world.
end--Broker_GarbageFu:OnProfileEnable()

function Broker_GarbageFu:OnEnteringWorld()
    self:RegisterEvent( "BAG_UPDATE", "OnBagUpdate" );
    self:RegisterEvent( "MERCHANT_SHOW", "OnMerchantOpen");
    self:RegisterEvent( "MERCHANT_CLOSED", "OnMerchantClose" );
    self:RegisterEvent( "ADDON_LOADED","OnAddOnLoaded" );
    self:RegisterEvent( "PLAYER_LEAVING_WORLD", "OnLeavingWorld" );
    self:UnregisterEvent( "PLAYER_ENTERING_WORLD" );
    if( not self.vars.UpdateTimerHandle ) then
        self.vars.UpdateTimerHandle = self:ScheduleRepeatingTimer( "Update", 2 );
    end--if
end--Broker_GarbageFu:OnEnteringWorld()

function Broker_GarbageFu:OnLeavingWorld()
    self:RegisterEvent( "PLAYER_ENTERING_WORLD", "OnEnteringWorld" );
    self:UnregisterEvent( "BAG_UPDATE" );
    self:UnregisterEvent( "MERCHANT_SHOW" );
    self:UnregisterEvent( "MERCHANT_CLOSED" );
    self:UnregisterEvent( "ADDON_LOADED" );
    self:UnregisterEvent( "PLAYER_LEAVING_WORLD" );
    if( self.vars.UpdateTimerHandle ) then
        self:CancelTimer( self.vars.UpdateTimerHandle );
        self.vars.UpdateTimerHandle = nil;
    end--if
end--Broker_GarbageFu:OnLeavingWorld()

function Broker_GarbageFu:Update()
    self:OnTextUpdate();
    self:UpdateTooltip();
end--Broker_GarbageFu:Update()

function Broker_GarbageFu:UpdateTooltip()
    if( self.vars.tooltip ) then
        self:OnTooltipUpdate();
    end--if
end--Broker_GarbageFu:UpdateTooltip()

function Broker_GarbageFu:OnTextUpdate()
    if( not self.vars.initialized ) then
        return;
    end--if

    local text = "";

    if( self:IsShowingBagSlots() ) then
        text = self:GetBagSlots();
    end--if
    if( self:IsShowingTotalValue() ) then
        local total = 0;

        for i, item in ipairs( self.vars.items ) do
            if( self:IsItemDroppable( item ) ) then
                total = total + item.totvalue;
            end--if
        end--for
        if( total > 0 ) then
            text = text .. self:GetMoneyString( total ) .. " ";
        end--if
    end--if
    if( self:IsShowingFirstDrop() ) then
        local item = self:GetFirstDroppableItem();

        if( item ) then
            if( item.name:len() > self:GetNameLength() ) then
                text = text .. self.vars.colors[item.qual].hex .. item.name:sub( 1, self:GetNameLength() - 2 ) .. " .. " .. "|r";
            else
                text = text .. self.vars.colors[item.qual].hex .. item.name .. "|r";
            end--if
            if( item.maxstack > 1 ) then
                text = text .. " |cffffff00" .. tostring( item.stack ) .. "|r";
            end--if
            text = text .. " " .. self:GetMoneyString( item.totvalue );
            if( self:IsItemIcon() ) then
               self.ldbobj.icon = item.tex;
            end--if
        else
            if( self:IsItemIcon() ) then
                self.ldbobj.icon = "Interface\\AddOns\\Broker_GarbageFu\\Icon";
            end--if
            text = text.."|cff777777"..L["No items to drop"].."|r";
        end--if
    end--if
    self.ldbobj.text = text;
    self:HighlightSellAllButton();
end--Broker_GarbageFu:OnTextUpdate()

function Broker_GarbageFu:OnTooltipUpdate()
    if( not self.vars.initialized ) then
        return;
    end--if
    
    local tooltip = self.vars.tooltip;
    local line, column;
    local total = 0;
    local items = 0;
    local colors = self.vars.colors;
    local IsPriceType = self:IsPriceType();

    tooltip:Clear();
    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, L["GarbageFu"], tooltip:GetHeaderFont(), nil, nil, tooltip:GetColumnCount() );
    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, " ", nil, nil, tooltip:GetColumnCount() );

    for _, item in ipairs( self.vars.items ) do
        if( self:IsItemDroppable( item ) ) then
            local stacktext = "|r";

            if( item.maxstack > 1 ) then
                stacktext = stacktext .. ("|r |cffffff00(%i/%i)|r |r |cffffff00"):format( item.stack, item.maxstack );
            end--if
            total = total + item.totvalue;
            items = items + 1;
            line, column = tooltip:AddLine();
            if( IsPriceType ) then
                line, column = tooltip:SetCell( line, column, colors[item.qual].hex .. item.name .. stacktext, nil, nil, nil, clickProvider, self, item );
                line, column = tooltip:SetCell( line, column, self:GetMoneyString( item.totvalue ), nil, nil, nil, clickProvider, self, item );
                line, column = tooltip:SetCell( line, column, item.pricetype, nil, nil, nil, clickProvider, self, item );
            else
                line, column = tooltip:SetCell( line, column, colors[item.qual].hex .. item.name .. stacktext, nil, nil, -1, clickProvider, self, item );
                line, column = tooltip:SetCell( line, column, self:GetMoneyString( item.totvalue ), nil, "RIGHT", nil, clickProvider, self, item );
            end--if
        end--if
    end--for
    if( items > 1 ) then
        line, column = tooltip:AddLine();
        line, column = tooltip:SetCell( line, column, L["Total"], nil, "RIGHT", -1 );
        line, column = tooltip:SetCell( line, column, self:GetMoneyString( total ), nil, "RIGHT" );
    end--if
    if( self:IsShowingStatistics() ) then
        --    Added by Scott Calculate total of all garbage items sold and display
        local total = 0;
        local garbageprofit = self.db.realm.garbageprofit;
        local garbagedropped = self.db.realm.garbagedropped;

        line, column = tooltip:AddLine();
        line, column = tooltip:SetCell( line, column, "|CFF99FF99" .. L["BankedProfit"], nil, nil, tooltip:GetColumnCount() );
        if( ( next( garbageprofit ) ~= UnitName( "player" ) ) or next( garbageprofit, UnitName( "player" ) ) ) then
            local t = {};

            for name in pairs( garbageprofit ) do
                table.insert( t, name )
            end--for
            if( not self.sort_func ) then
                self.sort_func = function( alpha, bravo )
                                     return garbageprofit[alpha] < garbageprofit[bravo];
                                 end;
            end--if
            table.sort( t, self.sort_func );
            for _, name in pairs( t ) do
                local value = garbageprofit[name];

                self.vars.tooltip:AddLine( name, self:GetMoneyString( value ) );
                total = total + value;
            end--for
            t = nil;
        else
            total = garbageprofit[UnitName( "player" )];
        end--if
        line, column = tooltip:AddLine();
        line, column = tooltip:SetCell( line, column, "|CFF99FF99" .. L["Total Profit"], nil, "RIGHT", -1 );
        line, column = tooltip:SetCell( line, column, self:GetMoneyString( total ) );
        --    Added by Scott Calculate total of all garbage items dropped and display

        local total = 0

        line, column = tooltip:AddLine();
        line, column = tooltip:SetCell( line, column, "|CFF99FF99" .. L["DroppedProfit"], nil, nil, tooltip:GetColumnCount() );
        if( ( next( garbagedropped ) ~= UnitName( "player" ) ) or next( garbagedropped, UnitName( "player" ) ) ) then
            local t = {};

            for name in pairs( garbagedropped ) do
                table.insert( t, name );
            end--for
            if( not self.sort_func ) then
                self.sort_func = function( alpha, bravo )
                                     return garbagedropped[alpha] < garbagedropped[bravo];
                                 end;
            end--if
            table.sort(t, self.sort_func)
            for _,name in pairs( t ) do
                local value = garbagedropped[name];

                line = tooltip:AddLine( name, self:GetMoneyString( value ) );
                total = total + value;
            end--for
            t = nil;
        else
            total = garbagedropped[UnitName( "player" )];
        end--if
        line, column = tooltip:AddLine();
        line, column = tooltip:SetCell( line, column, "|CFF99FF99" .. L["Total Loss"], nil, "RIGHT", -1 );
        line, column = tooltip:SetCell( line, column, self:GetMoneyString( total ), nil, "RIGHT" );
    end--if
    
    if( MerchantFrame:IsVisible() ) then
        if( self:IsShowingFirstDrop() ) then
            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, column, " ", nil, nil, tooltip:GetColumnCount() );
            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, column, L["Hint1_item"] .. "\n" .. L["Hint1"], tooltip:GetHeaderFont(), nil, tooltip:GetColumnCount() );
        else
            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, column, " ", nil, nil, tooltip:GetColumnCount() );
            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, column, "\n" .. L["Hint1"], tooltip:GetHeaderFont(), nil, tooltip:GetColumnCount() );
        end--if
    else
        if( self:IsShowingFirstDrop() ) then
            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, column, " ", nil, nil, tooltip:GetColumnCount() );
            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, column, L["Hint2_item"] .. "\n" .. L["Hint2"], tooltip:GetHeaderFont(), nil, tooltip:GetColumnCount() );
        else
            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, column, " ", nil, nil, tooltip:GetColumnCount() );
            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, column, "\n" .. L["Hint2"], tooltip:GetHeaderFont(), nil, tooltip:GetColumnCount() );
        end--if
    end--if
end--Broker_GarbageFu:OnTooltipUpdate()

function Broker_GarbageFu:OnMenuRequest( level, value, inTooltip, value2 )
    if( not self.vars.initialized ) then
        return;
    end--if
    if( level == 1 ) then
        local item = self:GetFirstDroppableItem();

        if( item ) then
            local text = self.vars.colors[item.qual].hex .. item.name .. "|r";

            if( item.maxstack > 1 ) then
                text = text .. " |cffffff00x" .. tostring( item.stack ) .. "|r";
            end--if
            dewdrop:AddLine( "text", text .. " " .. self:GetMoneyString( item.totvalue ),
                "notClickable", true, "checked", true, "checkIcon", item.tex );

            local text = MerchantFrame:IsVisible() and L["Sell this item"] or L["Drop this item"];

            dewdrop:AddLine( "text", text, "arg1", self, "func", "DropFirstItem", "tooltipTitle", text,
                "tooltipText", L["Drops this item, or sells it if the vendor window is open"] );
            if( item.qual > 0 ) then
                dewdrop:AddLine( "text", L["Keep this item"], "arg1", self, "func", "KeepFirstItem",
                    "tooltipTitle", L["Keep this item"], "tooltipText", L["Adds this item to the keep items list"]);
            end--if
            self:BuildSellMenu( level, value, inTooltip, value2 );
            if( ( item.qual > 0 ) or ( item.totvalue == 0 ) or self.db.global.overrideprices[item.id] ) then
                dewdrop:AddLine( "text", L["Edit value for this item"], "hasArrow", true,
                    "hasEditBox", true, "editBoxText", tostring( item.value ),
                    "editBoxArg1", self, "editBoxFunc", Broker_GarbageFu.SetFirstItemValue,
                    "editBoxChangeArg1", self, "editBoxChangeFunc", Broker_GarbageFu.ValidateValue,
                    "tooltipTitle", L["Edit value for this item"], "tooltipText", L["Value TooltipText"] );
            end--if
            dewdrop:AddLine( "" );
        end--if
        dewdrop:AddLine( "text", L["Drop"], "hasArrow", true, "value", "drop" );
        dewdrop:AddLine( "text", L["Keep"], "hasArrow", true, "value", "keep" );
        self:BuildAuctionMenu( level, value, inTooltip, value2 );
        dewdrop:AddLine( "text", L["Edit item values"], "hasArrow", true, "value", "itemvalue" );
        dewdrop:AddLine( "" );
        dewdrop:AddLine( "text", L["Options"], "hasArrow", true, "value", "options" );
    elseif( level == 2 ) then
        if( value == "drop" ) then
            dewdrop:AddLine( "text", L["Drop"], "isTitle", true );
            dewdrop:AddLine( "text", L["Drop Sets"], "hasArrow", true, "value", "dropsets" );
            self:BuildDropTypeMenu( level - 1, value, inTooltip, value2 );
            dewdrop:AddLine( "text", L["Drop Items"], "hasArrow", true, "value", "dropitem" );
        elseif ( value == "keep" ) then
            dewdrop:AddLine( "text", L["Keep"], "isTitle", true );
            dewdrop:AddLine( "text", L["Keep Sets"], "hasArrow", true, "value", "keepsets" );
            self:BuildKeepTypeMenu( level - 1, value, inTooltip, value2 );
            dewdrop:AddLine( "text", L["Keep Items"], "hasArrow", true, "value", "keepitem" );
        elseif ( value == "itemvalue" ) then
            -- Edit item values
            dewdrop:AddLine( "text", L["Edit item values"], "isTitle", true );

            local tbl = self:GetCustomItemValueTable();

            for _, i in ipairs( tbl ) do
                dewdrop:AddLine( "text", self.vars.colors[i.qual].hex .. i.name,
                    "checked", self.db.global.overrideprices[i.id] ~= nil, "hasArrow", true, "hasEditBox", true,
                    "editBoxText", tostring(i.value),
                    "editBoxArg1", self, "editBoxArg2", i.id, "editBoxFunc", GarbageFu.SetItemValue,
                    "editBoxChangeArg1", self, "editBoxChangeFunc", GarbageFu.ValidateValue,
                    "tooltipTitle", L["Edit value for this item"], "tooltipText", L["Value TooltipText"] );
            end--for
            --tbl = nil;
        elseif( value == "options" ) then
            self:BuildVendorOptionMenu( level - 1, value, inTooltip, value2 );
            self:BuildAuctionOptionMenu( level - 1, value, inTooltip, value2 );
            dewdrop:AddLine( "" );
        else
            self:BuildAuctionMenu( level, value, inTooltip, value2 );
        end--if
    elseif( level == 3 ) then
        if( value2 == "drop" ) then
            if( value == "dropsets" ) then
                -- Drop - Sets
                dewdrop:AddLine( "text", L["Drop Sets"], "isTitle", true );
                for n, i in ipairs( self.vars.sets ) do
                    if( not i.auctionOnly ) then
                        local checked = self:IsDropSetSelected( n );
                        local checkIcon = "Interface\\Buttons\\UI-CheckBox-Check";

                        if( self:IsChildDropSetSelected( n ) ) then
                            checked = true;
                            checkIcon = "Interface\\Buttons\\UI-CheckBox-Check-Disabled";
                        end--if
                        dewdrop:AddLine( "text", i.name,
                            "checked", checked, "checkIcon", checkIcon,
                            "disabled", self:IsKeepSetSelected(n),
                            "hasArrow", i.sub ~= nil, "value", n,
                            "arg1", self, "arg2", n, "func", "ToggleDropSet" );
                    end--if
                end--for
            elseif ( value == "dropitem" ) then
                -- Drop - Items
                dewdrop:AddLine( "text", L["Drop Items"], "isTitle", true );

                local tbl = self:GetDropItemTable();

                for _,i in ipairs(tbl) do
                    dewdrop:AddLine( "text", self.vars.colors[i.qual].hex .. i.name,
                        "checked", self:IsDropItem(i.id),
                        "arg1", self, "arg2", i.id, "func", "ToggleDropItem");
                end--for
            else
                self:BuildDropTypeMenu( level - 1, value, inTooltip, value2 );
            end--if
        elseif(value2 == "keep") then
            if( value == "keepsets" ) then
                -- Keep - Sets
                dewdrop:AddLine( "text", L["Keep Sets"], "isTitle", true );
                for n, i in ipairs( self.vars.sets ) do
                    if( not i.auctionOnly ) then
                        local checked = self:IsKeepSetSelected( n );
                        local checkIcon = "Interface\\Buttons\\UI-CheckBox-Check";

                        if( self:IsChildKeepSetSelected( n ) ) then
                            checked = true;
                            checkIcon = "Interface\\Buttons\\UI-CheckBox-Check-Disabled";
                        end--if
                        dewdrop:AddLine( "text", i.name,
                            "checked", checked, "checkIcon", checkIcon,
                            "disabled", self:IsDropSetSelected( n ),
                            "hasArrow", i.sub ~= nil, "value", n,
                            "arg1", self, "arg2", n, "func", "ToggleKeepSet" );
                    end--if
                end--for
            elseif( value == "keepitem" ) then
                -- Keep - Items
                dewdrop:AddLine( "text", L["Keep Items"], "isTitle", true );

                local tbl = self:GetKeepItemTable();

                for _, i in ipairs( tbl ) do
                    dewdrop:AddLine( "text", self.vars.colors[i.qual].hex .. i.name,
                        "checked", self:IsKeepItem( i.id ),
                        "arg1", self, "arg2", i.id, "func", "ToggleKeepItem" );
                end--for
            else
                self:BuildKeepTypeMenu(level-1, value, inTooltip, value2);
            end--if
        elseif( value2 == "options" ) then
            self:BuildVendorOptionMenu( level - 1, value, inTooltip, value2 );
            self:BuildAuctionOptionMenu( level - 1, value, inTooltip, value2 );
        else
            self:BuildAuctionMenu( level, value, inTooltip, value2 );
        end--if
    elseif( level == 4 ) then
        if( value2 == "dropsets" ) then
            dewdrop:AddLine( "text", L["Drop Set"] .. " " .. self.vars.sets[value].name, "isTitle", true );
            for n, i in ipairs( self.vars.sets[value].sub ) do
                if( not i.auctionOnly ) then
                    dewdrop:AddLine( "text", i.name,
                        "checked", self:IsDropSetSelected(value,n),
                        "disabled",self:IsKeepSetSelected(value,n),
                        "arg1", self, "arg2", value, "arg3", n, "func", "ToggleDropSet" );
                end--if
            end--for
        elseif ( value2 == "keepsets" ) then
            dewdrop:AddLine( "text", L["Keep Set"] .. " " .. self.vars.sets[value].name, "isTitle", true );
            for n, i in ipairs( self.vars.sets[value].sub ) do
                if( not i.auctionOnly ) then
                    dewdrop:AddLine( "text", i.name,
                        "checked", self:IsKeepSetSelected(value,n),
                        "disabled", self:IsDropSetSelected(value,n),
                        "arg1", self, "arg2", value, "arg3", n, "func", "ToggleKeepSet" );
                end--if
            end--for
        else
            self:BuildDropTypeMenu( level - 1, value, inTooltip, value2 );
            self:BuildKeepTypeMenu( level - 1, value, inTooltip, value2 );
            self:BuildAuctionMenu( level, value, inTooltip, value2 )
        end--if
    end--if
end--Broker_GarbageFu:OnMenuRequest( level, value, inTooltip, value2 )

function Broker_GarbageFu:OnClick( button )
    if( not self.vars.initialized ) then
        return;
    end--if
    if( button == "RightButton" ) then
        if( self.vars.tooltip ) then
            self.vars.tooltip:SetScript( "OnLeave", nil );
            qtip:Release( self.vars.tooltip );
            self.vars.tooltip = nil;
        end--if
        dewdrop:Register( self.vars.frame,
            "children", function( level, value, valueN_1, valueN_2, valueN_3, valueN_4 )
                            if( level == 1 ) then
                                dewdrop:AddLine(
                                    "text", L["GarbageFu"],
                                    "isTitle", true );
                                self:OnMenuRequest( level, value, false, valueN_1, valueN_2, valueN_3, valueN_4 );
                                dewdrop:AddLine(
                                    "text", CLOSE,
                                    "tooltipTitle", CLOSE,
                                    "tooltipText", CLOSE_DESC,
                                    "func", dewdrop.Close,
                                    "arg1", dewdrop );
                            else
                                self:OnMenuRequest( level, value, false, valueN_1, valueN_2, valueN_3, valueN_4 );
                            end--if
                        end,
            "point", function( frame )
                         local x, y = self.vars.frame:GetCenter();
                         local leftRight;
    
                         if( x < GetScreenWidth() / 2 ) then
                             leftRight = "LEFT";
                         else
                             leftRight = "RIGHT";
                         end--if
                         if( y < GetScreenHeight() / 2 ) then
                             return "BOTTOM" .. leftRight, "TOP" .. leftRight;
                         else
                             return "TOP" .. leftRight, "BOTTOM" .. leftRight;
                         end--if
                    end,
            "dontHook", true );

        dewdrop:Open( self.vars.frame, "cursorX", true, "cursorY", true );
        return;
    end--if
    if( IsShiftKeyDown() and self:IsShowingFirstDrop() ) then
        self:DropFirstItem();
        return;
    end--if
    if( IsControlKeyDown() ) then
        self:KeepFirstItem();
        return;
    end--if
    -- Support OneBag
    if( OneBag ) then
        OneBag:ToggleBag( 0 );
        return;
    end--if
    if( Baggins ) then
        Baggins:ToggleAllBags();
        return;
    end--if
    if( not ContainerFrame1:IsShown() ) then
        ToggleBackpack();
        for i = 1, NUM_BAG_SLOTS do
            if( ( not self.vars.bags[i].ignore ) and ( self.vars.bags[i].numSlots > 0 ) and ( not _G["ContainerFrame" .. ( i + 1 )]:IsShown() ) ) then
                ToggleBag( i );
            end--if
        end--for
    else
        for i = 0, NUM_BAG_SLOTS do
            if( _G["ContainerFrame" .. ( i + 1 )]:IsShown() ) then
                _G["ContainerFrame" .. ( i + 1 )]:Hide()
            end--if
        end--for
    end--if
end--Broker_GarbageFu:OnClick( button )
------------------------------------------------------------------------------------------------------
-- Event functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:OnClickItem( item )
    if( IsShiftKeyDown() ) then
        self:DropItem( item );
    end--if
    if( IsControlKeyDown() ) then
        self:KeepItem( item );
    end--if
end--Broker_GarbageFu:OnClickItem( item )

function Broker_GarbageFu:OnMerchantOpen()
    self:HighlightSellAllButton();
    if( self.db.profile.sellonopen and ( not IsModifierKeyDown() ) ) then
        self:SellAllItems();
    end--if
end--Broker_GarbageFu:OnMerchantOpen()

function Broker_GarbageFu:OnMerchantClose()
    self:StopSelling();
end--Broker_GarbageFu:OnMerchantClose()

function Broker_GarbageFu:OnAddOnLoaded( _, addon )
    self:CheckAuctionAddonLoaded( addon );
    self:CheckVendorAddonLoaded( addon );
end--Broker_GarbageFu:OnAddOnLoaded( addon )

function Broker_GarbageFu:OnBagUpdate( _, bag )
    self:DebugPrint( "OnBagUpdate bag=" .. tostring( bag ) );
    if( ( not bag ) or ( bag < 0 ) or ( bag > NUM_BAG_SLOTS ) ) then
        return;
    end--if
    if( self.vars.bags[bag].bagName ~= GetBagName( bag ) ) then -- Houston, we got a problem
        self:DebugPrint( "New or changed bag detected. Doing a full scan" );
        self:InitBagScan(); -- New or changed bag detected. Do a full scan
        return;
    end--if
    if( self.vars.bags[bag].ignore ) then
        return
    end--if
    self:SetSafeToDelete( false );
    for slot = 1, self.vars.bags[bag].numSlots do
        if( not self.vars.bags[bag][slot] ) then
            self.vars.bags[bag][slot] = {}
        end--if

        local link = GetContainerItemLink( bag, slot );
        local _, stack = GetContainerItemInfo( bag, slot );

        if( ( link ~= self.vars.bags[bag][slot].link ) or ( stack ~= self.vars.bags[bag][slot].stack ) ) then
            self.vars.bags[bag][slot].link = link;
            self.vars.bags[bag][slot].stack = stack;
            self:UpdateItem( bag,slot );
            self:SortItems();
        end--if
    end--for
    self:SetSafeToDelete( true );
end--Broker_GarbageFu:OnBagUpdate( bag )

------------------------------------------------------------------------------------------------------
-- Core functions
------------------------------------------------------------------------------------------------------

--
function Broker_GarbageFu:MainInit()
    self:MakeSetsTables();
    self:InitBagScan();
    self:InitSell();
end--Broker_GarbageFu:MainInit()

function Broker_GarbageFu:InitBagScan()
    self:SetSafeToDelete( false );
    self.vars.items = {};
    for bag = 0, NUM_BAG_SLOTS do
        self.vars.bags[bag] = {
            numSlots = GetContainerNumSlots( bag ),
            bagName = GetBagName( bag ),
            ignore = self:IgnoreBag( bag ),
        };
        if( not self.vars.bags[bag].ignore ) then
            for slot = 1, self.vars.bags[bag].numSlots do
                self.vars.bags[bag][slot] = {
                    link = GetContainerItemLink( bag, slot ),
                };
                _, self.vars.bags[bag][slot].stack = GetContainerItemInfo( bag, slot );
                self:UpdateItem( bag,slot );
            end--for
        end--if
    end--for
    self:SortItems();
    self:SetSafeToDelete( true );
end--Broker_GarbageFu:InitBagScan()

function Broker_GarbageFu:UpdateItem( bag, slot )
    local itemidx = nil;
    local item = nil;

    for a, i in ipairs( self.vars.items ) do
        if( ( i.bag == bag ) and ( i.slot == slot ) ) then
            itemidx = a;
            item = i;
            break;
        end--if
    end--for
    if( self.vars.bags[bag][slot].link ) then
        if( ( not item ) or ( item.link ~= self.vars.bags[bag][slot].link ) ) then  -- New or changed item
            item = { -- Clear all old values
                ["bag"] = bag,
                ["slot"] = slot,
                ["link"] = self.vars.bags[bag][slot].link,
                ["stack"] = self.vars.bags[bag][slot].stack,
            };

            local color;

            item.id, item.code, item.name, color = self:GetItemId( item.link );
            if( item.id ) then
                self:GetItemType( item );
                if( not item.qual ) then --- Item not in local cache
                    item.qual = self:GetItemQualFromColor( color );
                    item.tex = "Interface\\Icons\\INV_Misc_QuestionMark.blp";
                    item.maxstack = 0;
                    item.notseen = true;
                else
                    item.notseen = nil;
                end--if
                self:GetItemValue( item );
            else
                item.notseen = true;
            end--if
            self:DebugPrint( "New item:%s bag:%d slot:%d", item.name, item.bag, item.slot );
        else -- Just new stack size, recalc totvalue
            item.stack = self.vars.bags[bag][slot].stack;
            if( item.value ) then
                item.totvalue = item.value * item.stack;
            end
            self:DebugPrint( "Item stack updated:%s bag:%d slot:%d", item.name, item.bag, item.slot );
        end--if
        if( not itemidx ) then
            table.insert( self.vars.items, item );  -- New item added
        else
            self.vars.items[itemidx] = item;
        end--if
    elseif( itemidx ) then
        self:DebugPrint( "Item removed:%s bag:%d slot:%d", item.name, item.bag, item.slot );
        table.remove( self.vars.items, itemidx ); -- Item removed
    end--if
end--Broker_GarbageFu:UpdateItem( bag, slot )

function Broker_GarbageFu:SortItems()
    table.sort( self.vars.items, function( item1, item2 )
                                     return ( ( not item1.notseen ) and ( item2.notseen or ( item1.totvalue < item2.totvalue ) or ( ( item1.totvalue == item2.totvalue ) and ( item1.id < item2.id ) ) ) );
                                 end );
    self:UpdateDisplay();
end--Broker_GarbageFu:SortItems()

function Broker_GarbageFu:GetItemId( link )
  if( link ) then
        local _, _, color, code, id, name = link:find( "|cff(%x%x%x%x%x%x)|Hitem:((%d+):%d+:%d+:%d+:%d+:%d+:%-?%d+:%-?%d+).+%[(.+)%]" );

        return tonumber( id ), code, name, color;
  end--if
end--Broker_GarbageFu:GetItemId( link )

function Broker_GarbageFu:GetItemQualFromColor( color )
    for i, c in ipairs( self.vars.colors ) do
        if( color == c.hex:sub( 5 ) ) then
            return i;
        end--if
    end--for
end--Broker_GarbageFu:GetItemQualFromColor( color )


-- Check if an item is elegiable for drop
function Broker_GarbageFu:IsItemDroppable( item )
    if( item.notseen ) then
        self:UpdateItem( item.bag,item.slot ); -- Not seen item. Try again.
    end--if
    if( item.notseen ) then
        return false; -- Still not seen.
    end--if
    if( ( item.totvalue == 0 ) and ( item.qual > 0 ) ) then
       return false; -- All items above poor quality without price is not dropped for saftey reasons
    end--if
    if( self:IsItemKeepItem( item.id ) ) then
        return false;
    end--if
    if( self:IsItemDropItem( item.id ) ) then
        return true;
    end--if
    if( self:IsItemKeepType( item ) ) then
        return false;
    end--if
    if( self:IsItemInKeepSets( item.id ) ) then
        return false;
    end--if
    if( self:IsItemDropType( item ) ) then
        return true;
    end--if
    if( self:IsItemInDropSets( item.id ) ) then
        return true;
    end--if
    if( item.qual <= self:GetDropThreshold() ) then
        return true;
    end--if
    return false;
end--Broker_GarbageFu:IsItemDroppable( item )

function Broker_GarbageFu:GetFirstDroppableItem()
    for i, item in ipairs( self.vars.items ) do
        if( self:IsItemDroppable( item ) ) then
            return item;
        end--if
    end--for
end--Broker_GarbageFu:GetFirstDroppableItem()

function Broker_GarbageFu:GetBagSlots()
    local total = 0;
    local used = 0;

    for bag = 0, NUM_BAG_SLOTS do
        if( self.vars.bags and self.vars.bags[bag] and ( not self.vars.bags[bag].ignore ) ) then
            total = total + self.vars.bags[bag].numSlots;
            for slot = 1, self.vars.bags[bag].numSlots do
                if( self.vars.bags[bag][slot] and self.vars.bags[bag][slot].link ) then
                    used = used + 1;
                end--if
            end--for
        end--if
    end--for

    local color = crayon:GetThresholdHexColor( ( total - used ) / total );

    if( self:IsShowingTotalSlots() ) then
        if self:IsShowingFreeSlots() then
            used = total - used;
        end--if
        return ("|cff%s%d/%d|r "):format( color, used, total );
    else
        if( self:IsShowingFreeSlots() ) then
            used = total - used;
        end--if
        return ("|cff%s%d|r "):format( color, used );
    end--if
end--Broker_GarbageFu:GetBagSlots()

-- Upgrades user settings
function Broker_GarbageFu:CheckSettings()
    -- Make a list of all valid sets id's
    local hash = {};

    for _, set in ipairs( self.vars.sets ) do
        if( set.auctionOnly ) then
            hash[set.id] = 2;
        else
            hash[set.id] = 1;
        end--if
        if( set.sub ) then
            for _, subset in ipairs( set.sub ) do
                if( subset.auctionOnly ) then
                    hash[subset.id] = 2;
                else
                    hash[subset.id] = 1;
                end--if
            end--for
        end--if
    end--for
    self:UpgradeSetNames( self.db.profile.dropsets );
    self:UpgradeSetNames( self.db.profile.keepsets );
    self:UpgradeSetNames( self.db.profile.auctionsets );
    -- Check dropsets
    for setid, _ in pairs( self.db.profile.dropsets ) do
        if( ( not hash[setid] ) or ( hash[setid] ~= 1 ) ) then
            self.db.profile.dropsets[setid] = nil;        -- Deleteing invalid setid
        end--if
    end--for
    -- Check keepsets
    for setid, _ in pairs( self.db.profile.keepsets ) do
        if( ( not hash[setid] ) or ( hash[setid] ~= 1 ) ) then
            self.db.profile.keepsets[setid] = nil;        -- Deleteing invalid setid
        end--if
    end--for
    -- check auctionsets
    for setid, _ in pairs( self.db.profile.auctionsets ) do
        if( not hash[setid] ) then
            self.db.profile.auctionsets[setid] = nil;        -- Deleteing invalid setid
        end--if
    end--for
    hash = nil;
    -- check vendor addons
    for _, addon in pairs( self.db.profile.vendoraddonsorder ) do
        if( not self.vars.vendoraddons[addon] ) then
            self.db.profile.vendoraddonsorder[addon] = nil;
        end--if
    end--for
    -- check auction addons
    for _, addon in pairs( self.db.profile.auctionaddonsorder ) do
        if( not self.vars.auctionaddons[addon] ) then
            self.db.profile.auctionaddonsorder[addon] = nil;
        end--if
    end--for
end--Broker_GarbageFu:CheckSettings()

-- Upgrade set names for PT3
function Broker_GarbageFu:UpgradeSetNames( profileset )
    local converttbl= {
        ["foodall"] = "Consumable.Food",
        ["food"] = "Consumable.Food.Edible.Basic.Non-Conjured", 
        ["foodbonus"] = "Consumable.Food.Edible.Bonus", 
        ["foodstat"] = "Consumable.Food.Buff",
        ["foodbreadconjured"] = "Consumable.Food.Edible.Basic.Conjured",
        ["foodraw"] = "Consumable.Food.Inedible",
        ["foodclassbread"] = "Consumable.Food.Bread", 
        ["foodclassfish"] = "Consumable.Food.Fish", 
        ["foodclassmeat"] = "Consumable.Food.Meat", 
        ["foodclasscheese"] = "Consumable.Food.Cheese", 
        ["foodclassfruit"] = "Consumable.Food.Fruit", 
        ["foodclassfungus"] = "Consumable.Food.Fungus", 
        ["waterall"] = "Consumable.Water", 
        ["water"] = "Consumable.Water.Basic", 
        ["waterperc"] = "Consumable.Water.Percentage", 
        ["waterconjured"] = "Consumable.Water.Conjured", 
        ["booze"] = "Misc.Booze", 
        ["tradeskill"] = "Tradeskill.Mat.ByProfession", 
        ["tradeskillalchemy"] = "Tradeskill.Mat.ByProfession.Alchemy", 
        ["tradeskillblacksmithing"] = "Tradeskill.Mat.ByProfession.Blacksmithing", 
        ["tradeskillcooking"] = "Tradeskill.Mat.ByProfession.Cooking", 
        ["tradeskillenchanting"] = "Tradeskill.Mat.ByProfession.Enchanting", 
        ["tradeskillengineering"] = "Tradeskill.Mat.ByProfession.Engineering", 
        ["tradeskillfirstaid"] = "Tradeskill.Mat.ByProfession.First Aid", 
        ["tradeskillleatherworking"] = "Tradeskill.Mat.ByProfession.Leatherworking", 
        ["tradeskilltailoring"] = "Tradeskill.Mat.ByProfession.Tailoring", 
        ["tradeskillpoison"] = "Tradeskill.Mat.ByProfession.Poisons", 
        ["tradeskillsmelting"] = "Tradeskill.Mat.ByProfession.Smelting", 
        ["tradeskilltools"] = "Tradeskill.Tool", 
        ["gatherskill"] = "Tradeskill.Gather", 
        ["gatherskillfishing"] = "Tradeskill.Gather.Fishing", 
        ["gatherskilldisenchant"] = "Tradeskill.Gather.Disenchant", 
        ["gatherskillherbalism"] = "Tradeskill.Gather.Herbalism", 
        ["gatherskillmining"] = "Tradeskill.Gather.Mining", 
        ["gatherskillskinning"] = "Tradeskill.Gather.Skinning", 
        ["recipe"] = "Tradeskill.Recipe", 
        ["recipealchemy"] = "Tradeskill.Recipe.Alchemy", 
        ["recipeblacksmith"] = "Tradeskill.Recipe.Blacksmithing", 
        ["recipecooking"] = "Tradeskill.Recipe.Cooking", 
        ["recipeenchanting"] = "Tradeskill.Recipe.Enchanting",
        ["recipeengineering"] = "Tradeskill.Recipe.Engineering",
        ["recipefishing"] = "Tradeskill.Recipe.Fishing",
        ["recipefirstaid"] = "Tradeskill.Recipe.First Aid", 
        ["recipeleatherworking"] = "Tradeskill.Recipe.Leatherworking", 
        ["recipetailoring"] = "Tradeskill.Recipe.Tailoring", 
        ["ammo"] = "Reagent.Ammo", 
        ["bandages"] = "Consumable.Bandage",
        ["explosives"] = "Misc.Engineering.Explosives", 
        ["faire"] = "QuestMats.Darkmoon Faire", 
        ["fireworks"] = "Misc.Engineering.Fireworks", 
        ["potionall"] = "Consumable.Potion", 
        ["potionhealall"] = "Consumable.Potion.Recovery.Healing", 
        ["potionmanaall"] = "Consumable.Potion.Recovery.Mana", 
        ["potionrage"] = "Consumable.Buff.Rage.Self", 
        ["potioncure"] = "Consumable.Potion.Other.Cure", 
        ["potionbuff"] = "Consumable.Potion.Buff", 
        ["scrolls"] = "Consumable.Scroll", 
        ["reagent"] = "Reagent.Class", 
        ["reagentpaladin"] = "Reagent.Class.Paladin", 
        ["reagentdruid"] = "Reagent.Class.Druid", 
        ["reagentmage"] = "Reagent.Class.Mage", 
        ["reagentpriest"] = "Reagent.Class.Priest", 
        ["reagentrogue"] = "Reagent.Class.Rogue", 
        ["reagentshaman"] = "Reagent.Class.Shaman", 
        ["reagentwarlock"] = "Reagent.Class.Warlock", 
        ["weapontempenchants"] = "Consumable.Weapon Buff", 
        ["poisons"] = "Consumable.Weapon Buff.Poison", 
        ["mounts"] = "Misc.Mount", 
        ["minipetall"] = "Misc.Minipet",
    };

    for setid in pairs( profileset ) do
        if( converttbl[setid] ) then
            profileset[converttbl[setid]] = true;
        end--if
    end--for
end--Broker_GarbageFu:UpgradeSetNames( profileset )

-- Check that all items match what's actually in the bags
function Broker_GarbageFu:CheckBags()
    local failed = false;

    for i, item in ipairs( self.vars.items ) do
        if( not self:CheckItem( item ) ) then
            failed = true;
            break;
        end--if
    end--for
    if( failed ) then
        self:Print( "Item inconsistency found. Doing a complete rescan. Please report the errors along with what you did the last minute before it happened." );
        self:InitBagScan();
    end--if
end--Broker_GarbageFu:CheckBags()

-- Check that the item we have is the same as WoW says is in that slot.
function Broker_GarbageFu:CheckItem( item )
    if( not ( item and item.link and item.bag and item.slot ) ) then
        return false;
    end--if

    local link = GetContainerItemLink( item.bag, item.slot );

    if( item.link == link ) then
        return true;
    end--if
    self:MyPrint( "Error! Expected item %s in bag %d slot %d, but found %s", item.link, item.bag, item.slot, link );
    return false;
end--Broker_GarbageFu:CheckItem( item )
------------------------------------------------------------------------------------------------------
-- Drop down menu functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:GetDropItemTable()
    self.vars.temptbl = {};

    local tbl2 = {};

    -- Start with itemid's listed as drop
    for i, _ in pairs( self.db.profile.dropitem ) do
        local item = {
            id = i
        };

        item.name, _, item.qual = GetItemInfo(i);
        if( item.name ) then
            table.insert( self.vars.temptbl, item );
            tbl2[i] = true;
        else
            item = nil;
        end--if
    end--for
    -- Add items in inventory with a qual over drop threshold or in keep sets/type and not in drop set/type
    for _, i in ipairs( self.vars.items ) do
        if( ( not ( i.notseen or tbl2[i.id] ) ) and ( i.totvalue > 0 ) and
                 ( ( i.qual > self:GetDropThreshold() ) or self:IsItemInKeepSets( i.id ) or self:IsItemKeepType( i ) ) ) then
            local item = {
                id = i.id;
                name = i.name;
                qual = i.qual;
            };

            table.insert( self.vars.temptbl, item );
            tbl2[i.id] = true;
        end---if
    end
    tbl2 = nil;
    table.sort( self.vars.temptbl, function( a, b ) return a.name < b.name end );
    return self.vars.temptbl;
end--Broker_GarbageFu:GetDropItemTable()

function Broker_GarbageFu:GetKeepItemTable()
    self.vars.temptbl = {};

    local tbl2 = {};

    -- Start with itemid's listed as keep
    for i, _ in pairs( self.db.profile.keepitem ) do
        local item = {
            id = i
        };

        item.name, _, item.qual = GetItemInfo( i );
        if( item.name ) then
            table.insert( self.vars.temptbl, item );
            tbl2[i] = true;
        else
            item = nil;
        end--if
    end--for
    -- Add items in inventory with a qual eq or below drop threshold or in drop sets/type. Not poor quality items
    for _, i in ipairs( self.vars.items ) do
        if( ( ( i.qual <= self:GetDropThreshold() ) or self:IsItemInDropSets( i.id ) or self:IsItemDropType( i ) ) and
                ( not ( i.notseen  or tbl2[i.id] or
                self:IsItemInKeepSets( i.id ) or self:IsItemKeepType( i ) ) ) ) then
            local item = {
                id = i.id;
                name = i.name;
                qual = i.qual;
            };

            table.insert( self.vars.temptbl, item );
            tbl2[i.id] = true;
        end--if
    end--for
    tbl2 = nil;
    table.sort( self.vars.temptbl, function( a, b ) return a.name < b.name end );
    return self.vars.temptbl;
end--Broker_GarbageFu:GetKeepItemTable()

function Broker_GarbageFu:KeepFirstItem()
    local item = self:GetFirstDroppableItem();

    if( item ) then
        self:KeepItem( item );
    end--if
end--Broker_GarbageFu:KeepFirstItem()

function Broker_GarbageFu:KeepItem( item )
    if( item ) then
        self:ToggleKeepItem( item.id );
        self:MyPrint( L["Adding %s to keep item list"], item.link );
    end--if
end--Broker_GarbageFu:KeepItem( item )

function Broker_GarbageFu:DropFirstItem()
    local item = self:GetFirstDroppableItem();

    if( item ) then
        self:DropItem( item );
    end--if
end--Broker_GarbageFu:DropFirstItem()

function Broker_GarbageFu:DropItem( item )
    if( not ( item and item.bag and item.slot and self:CheckItem( item ) and self:IsSafeToDelete() ) ) then
        return;
    end--if

    if( self:IsItemDroppable(item) ) then
        if( MerchantFrame:IsVisible() ) then
            self:MyPrint( L["Selling x%s %s worth %s"], item.stack, item.name, self:GetMoneyString( item.totvalue ) );
            --    Added by Scott update the DB with the value of the garbage item sold
            self.db.realm.garbageprofit[UnitName( "player" )] = self.db.realm.garbageprofit[UnitName( "player" )] + item.totvalue;
            UseContainerItem( item.bag, item.slot );
            self:SetSafeToDelete( false );
        else
            self:MyPrint( L["Dropping x%s %s worth %s"], item.stack, item.name, self:GetMoneyString( item.totvalue ) );
            --    Added by Scott update the DB with the value of the garbage item dropped
            self.db.realm.garbagedropped[UnitName( "player" )] = self.db.realm.garbagedropped[UnitName( "player" )] + item.totvalue;
            PickupContainerItem( item.bag, item.slot );
            DeleteCursorItem();
            self:SetSafeToDelete( false );
        end--if
    end--if
end--Broker_GarbageFu:DropItem( item )

function Broker_GarbageFu:SettingsReset()
    self:ResetDB( "profile" );
    self:ResetDB( "global" );
    self.vars.dropsets = {};
    self.vars.keepsets = {};
    self.vars.auctionsets = {};
    self:UpdateDisplay();
end--Broker_GarbageFu:SettingsReset()

function Broker_GarbageFu:GetMoneyString( value )
    if( ( not value ) or ( value == 0 ) ) then
        return "|cffffcc00??|r"; -- No price
    elseif( self.db.profile.moneyformat == 1 ) then
        return abacus:FormatMoneyCondensed( value, true, true );
    elseif( self.db.profile.moneyformat == 2 ) then
        return abacus:FormatMoneyShort( value, true, true );
    elseif( self.db.profile.moneyformat == 3 ) then
        return abacus:FormatMoneyFull( value, true, true );
    else
        return abacus:FormatMoneyExtended( value, true, true );
    end--if
end--Broker_GarbageFu:GetMoneyString( value )

------------------------------------------------------------------------------------------------------
-- Sets functions
------------------------------------------------------------------------------------------------------

-- Converts self.db.profile.dropsets into self.vars.dropsets
-- Needed because self.db.profile.dropsets is index by name and self.vars.dropsets needs to be indexed by number with names as string.
function Broker_GarbageFu:MakeSetsTables()
    self.vars.dropsets = {};
    for n,_ in pairs(self.db.profile.dropsets) do
        table.insert(self.vars.dropsets,n);
    end
    self.vars.keepsets = {};
    for n,_ in pairs(self.db.profile.keepsets) do
        table.insert(self.vars.keepsets,n);
    end
end

function Broker_GarbageFu:IsItemInSet(itemId,set)
    if set and type(set) == "table" then
        for s,v in pairs(set) do
            local val,rset = PT3:ItemInSet(itemId,v);
            if val then return true end
        end
    end
end

function Broker_GarbageFu:IsSetSelected(set, subset, setstbl)
    local setid = self.vars.sets[set].id;
    if subset then
        local subsetid = self.vars.sets[set].sub[subset].id;
        return setstbl[setid] or setstbl[subsetid];
    end
    return setstbl[setid];
end

    function Broker_GarbageFu:IsChildSetSelected(set,setstbl)
        if self.vars.sets[set].sub then
            for _,s in ipairs(self.vars.sets[set].sub) do
                if setstbl[s.id] then
                    return true;
                end
            end
        end
    end

function Broker_GarbageFu:ToggleSets(set,subset,vartbl,setstbl1,setstbl2)
    self:DebugPrint("ToggleSets(set) set="..tostring(set).." subset="..tostring(subset));
    local setid = vartbl[set].id;
    if subset then                                                                    -- Clicked a child
        local subsetid = vartbl[set].sub[subset].id;
        if setstbl1[setid] then                                                  -- Check if parent is set
            setstbl1[setid] = nil;                                                     -- Clear parent
            for _,s in ipairs(vartbl[set].sub) do
                setstbl1[s.id] = true;                                                 -- Set all children
            end
        end
        if setstbl1[subsetid] then                                            -- Reverse child
            setstbl1[subsetid] = nil;
        else
            setstbl1[subsetid] = true;
        end
        local allset = true;
        for _,s in ipairs(vartbl[set].sub) do
            if not setstbl1[s.id] then                                         -- Check if all children are set
                allset = false;
                break;
            end
        end
        if allset then                                                                        -- All children are set
            setstbl1[setid] = true;                                                 -- set parent
            for i,s in ipairs(vartbl[set].sub) do
                setstbl1[s.id] = nil;                                                  -- And clear all children
            end
        end
    else                                                                                        -- Clicked a parent or a single
        if setstbl1[setid] then                                                    -- Reverse it
            setstbl1[setid] = nil;
        else
            setstbl1[setid] = true;
            if vartbl[set].sub then                                -- If it is a parent
                for _,s in ipairs(vartbl[set].sub) do                    -- Clear all children for both setstbl1 and setstbl2
                    setstbl1[s.id] = nil;
                    if setstbl2 then setstbl2[s.id] = nil end
                end
            end
        end
    end
end

-- Check if item is in one of the sets selected for drop.
function Broker_GarbageFu:IsItemInDropSets(itemid)
    return self:IsItemInSet(itemid,self.vars.dropsets);
end

-- Check if item is in one of the sets selected for keep.
function Broker_GarbageFu:IsItemInKeepSets(itemid)
    return self:IsItemInSet(itemid,self.vars.keepsets);
end

function Broker_GarbageFu:IsItemDropItem(itemid)
    return self.db.profile.dropitem[itemid] ~= nil;
end

function Broker_GarbageFu:IsItemKeepItem(itemid)
    return self.db.profile.keepitem[itemid] ~= nil;
end

function Broker_GarbageFu:IsDropSetSelected(set,subset)
    return self:IsSetSelected(set, subset, self.db.profile.dropsets);
end

function Broker_GarbageFu:IsKeepSetSelected(set,subset)
    return self:IsSetSelected(set, subset, self.db.profile.keepsets);
end

function Broker_GarbageFu:IsChildDropSetSelected(set)
    return self:IsChildSetSelected(set, self.db.profile.dropsets);
end

function Broker_GarbageFu:IsChildKeepSetSelected(set)
    return self:IsChildSetSelected(set, self.db.profile.keepsets);
end

function Broker_GarbageFu:ToggleDropSet(set,subset)
    self:ToggleSets(set, subset, self.vars.sets, self.db.profile.dropsets, self.db.profile.keepsets);
    self:MakeSetsTables();
    self:UpdateDisplay();
end

function Broker_GarbageFu:ToggleKeepSet(set,subset)
    self:ToggleSets(set, subset, self.vars.sets, self.db.profile.keepsets, self.db.profile.dropsets);
    self:MakeSetsTables();
    self:UpdateDisplay();
end

------------------------------------------------------------------------------------------------------
-- Special bag functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:GetBagId( bag )
    return self:GetItemId( GetInventoryItemLink( "player", ContainerIDToInventoryID( bag ) ) );
end--Broker_GarbageFu:GetBagId( bag )

function Broker_GarbageFu:IgnoreBag( bag )
    if( ( bag < 1 ) or ( bag > NUM_BAG_SLOTS ) ) then
        return;
    end--if

    local bagId = self:GetBagId( bag );

    if( not bagId ) then
        return;
    end--if

    local _, _, _, _, _, bagtype, bagsubtype = GetItemInfo( bagId );

    return ( self:IsIgnoringAmmoBag() and ( ( bagtype == L["Quiver"] ) or ( bagtype == L["Ammo Pouch"] ) ) ) or
        ( self:IsIgnoringSoulBag() and ( bagsubtype == L["Soul Bag"] ) ) or
        ( self:IsIgnoringHerbBag() and ( bagsubtype == L["Herb Bag"] ) ) or
        ( self:IsIgnoringEnchBag() and ( bagsubtype == L["Enchanting Bag"] ) ) or
        ( self:IsIgnoringEngBag() and ( bagsubtype == L["Engineering Bag"] ) ) or
        ( self:IsIgnoringGemBag() and ( bagsubtype == L["Gem Bag"] ) ) or
        ( self:IsIgnoringMinBag() and ( bagsubtype == L["Mining Bag"] ) ) or
        ( self:IsIgnoringLeatherBag() and ( bagsubtype == L["Leatherworking Bag"] ) );
end--Broker_GarbageFu:IgnoreBag( bag )

------------------------------------------------------------------------------------------------------
-- Item Price functions
------------------------------------------------------------------------------------------------------

-- Update all items in the inventory with new prices.
function Broker_GarbageFu:UpdateAllItemValues()
    for _, item in ipairs( self.vars.items ) do
        self:GetItemValue( item );
    end--for
    self:SortItems();
end--Broker_GarbageFu:UpdateAllItemValues()

-- Updates all occurances of itemid in the inventory with a new price.
function Broker_GarbageFu:UpdateItemValue( itemid )
    for _, item in ipairs( self.vars.items ) do
        if( item.id == itemid ) then
            self:GetItemValue( item );
        end--if
    end--for
    self:SortItems();
end--Broker_GarbageFu:UpdateItemValue( itemid )

-- Get item value. Doh!
function Broker_GarbageFu:GetItemValue( item )
    if( not self:GetAuctionValue( item ) ) then
        self:GetVendorValue( item );
    end--if
end--Broker_GarbageFu:GetItemValue( item )


------------------------------------------------------------------------------------------------------
-- Custom price override functions
------------------------------------------------------------------------------------------------------

-- Check that we got a numeric value from the editbox.
function Broker_GarbageFu:ValidateValue( value )
    self:DebugPrint( "ValidateValue value=" .. tostring( value ) );

    local res = ""

    for s in value:gmatch( "(%d*).-(%d*)" ) do
        res = res .. s;
    end--for
    return res;
end--Broker_GarbageFu:ValidateValue( value )

-- Stores a new User Override price for the top item.
function Broker_GarbageFu:SetFirstItemValue( value )
    local item = self:GetFirstDroppableItem();

    if( item ) then
        self:SetItemValue( self, item.id, value );
    end--if
end--Broker_GarbageFu:SetFirstItemValue( self, value )

-- Stores a new User Override price for an item, or removing it.
function Broker_GarbageFu.SetItemValue( self, itemid, value )
    value = tonumber( value );
    if( itemid ) then
        self:DebugPrint( "SetItemValue value=" .. tostring( value ) .. "itemid = " .. tostring( itemid ) );
        if( ( not value ) or ( value == 0 ) ) then
            if( self.db.global.overrideprices[itemid] ) then
                self.db.global.overrideprices[itemid] = nil;
                self:MyPrint( L["Removing custom price for %s."], select( 1, GetItemInfo( itemid ) ) );
            end--if
        else
            self.db.global.overrideprices[itemid] = value;
            self:MyPrint( L["Setting price for %s to %s."], select( 1, GetItemInfo( itemid ) ), self:GetMoneyString( value ) );
        end--if
        self:UpdateItemValue( itemid );
    end--if
end--Broker_GarbageFu.SetItemValue( self, itemid, value )

function Broker_GarbageFu:GetCustomItemValueTable()
    local tbl2 = {};

    self.vars.temptbl = {};
    -- Start with itemid's with a custom price
    for i,v in pairs( self.db.global.overrideprices ) do
        local item = {
            id = i,
            value = v,
        };

        item.name, _, item.qual = GetItemInfo( i );
        if( item.name ) then
            table.insert( self.vars.temptbl, item );
            tbl2[i] = true;
        else
            item = nil;
        end--if
    end--for
    -- Add items in inventory. Not poor quality items that already have a price
    for _, i in ipairs( self.vars.items ) do
        if( ( ( i.qual > 0 ) or ( i.totvalue == 0 ) ) and ( not ( i.notseen or tbl2[i.id] or
                self:IsItemInKeepSets( i.id ) or self:IsItemKeepType( i ) or
                self:IsItemKeepItem( i.id ) ) ) ) then
            local item = {
                id = i.id,
                name = i.name,
                qual = i.qual,
                value = i.value or 0,
            };

            table.insert( self.vars.temptbl, item );
            tbl2[i.id] = true;
        end--if
    end--for
    tbl2 = nil;
    table.sort( self.vars.temptbl, function( a, b ) return a.name < b.name end );
    return self.vars.temptbl;
end--Broker_GarbageFu:GetCustomItemValueTable()

------------------------------------------------------------------------------------------------------
-- Chat output functions
------------------------------------------------------------------------------------------------------

function Broker_GarbageFu:DebugPrint( a1, ... )
    if( self.CustomDebug ) then
        self:CustomDebug( 1, 0.5, 0, nil, nil, a1, ... );
    end--if
end--Broker_GarbageFu:DebugPrint( a1, ... )

function Broker_GarbageFu:MyPrint( a1, ... )
    self:Print( ("|cff%02x%02x%02x"):format( self.db.profile.textcolor.r * 255, self.db.profile.textcolor.g * 255, self.db.profile.textcolor.b * 255 ), a1:format( ... ) );
end--Broker_GarbageFu:MyPrint( a1, ... )
